//Name create message
//Description bulk-process some task by creating a message. 
//Message type, handler and resolution are given in human-readable form, not by inertnal numbers
//Type CSV Import 
//Comments: needs following CSV input
//Task,Message,Handler,Text,Resolution,Custom field 1,Custom field 2
// For every task of given number (column "Task"), creates a message of type in the column "Message" (like "Assign")
// Sets the task handler to the one given in the colummn "Handler" like "John Smith"
// Resolution, if given, will be set for the new message. Resolution is like "001 open problem"
// Custom field 1 and 2 will be set, if given.
Map objMap = new HashMap();
String number = inputMap.get("Task");
String id = CSVImport.findTaskIdByNumber(number);
String msgType = inputMap.get("Message");
String handler = inputMap.get("Handler");
String handlerId=CSVImport.findUserIdByName(handler);
if (handlerId == null) throw new Exception("Can't find handler "+handler);
// 
// 

if(id != null && msgType != null) {
  // FIXME: Task type should be changed to task category like "Software bug" or 
  // it could be derived from task id
  String statusId = CSVImport.findMessageTypeIdByName(msgType, "FIXME: Task category");
  if(statusId == null) throw new Exception("Can't find message type "+msgType);

  objMap.put(CSVImport.OBJECT_TYPE, CSVImport.MESSAGE_TYPE);
  objMap.put(CSVImport.MESSAGE_TASK_ID, id);
  objMap.put(CSVImport.MESSAGE_MESSAGE_TYPE_ID, statusId);
  objMap.put(CSVImport.MESSAGE_DESCRIPTION, inputMap.get("Text"));
  objMap.put(CSVImport.MESSAGE_HANDLER_USER_ID, handlerId);
  String res=inputMap.get("Resolution");
  if (res != null && res.length()>0) {
    String resId=CSVImport.findResolutionIdByName(res, msgType);
    objMap.put(CSVImport.MESSAGE_RESOLUTION_ID, resId);    
  }
  Map m = new HashMap();
  // FIXME change the names of custom (user-defined) fields as appropriate
  String udf1 = inputMap.get("Custom field 1");
  if (udf1 != null && udf1.length()>0) {
    m.put("Custom field 1", udf1);
  }
  String udf2 = inputMap.get("Custom field 2");
  if (udf2 != null && udf2.length()>0) {
    m.put("Custom field 2", udf2) ;
  }
  m.put("Typ", inputMap.get("Typ"));
  objMap.put(CSVImport.MESSAGE_UDF_MAP, m);
 } else {
  throw new Exception("message type or task not found!");
 }
return objMap; 
