//Name lookup values from task list
//Description: to get a list of task names from some folder
//Type Task / Custom Field Lookup
//Comments: if you want to store some release/version number in a task, you can store releases/versions as TrackStudio tasks
// and use a user-defined field of type "task" to put the release "task" in it. 
// But this would allow to put any task in the field, if you don't make further validations.
// This script gives a list of task names from some fixed folder, so instead of storing a refrence to a task
// you will be storing just a name of it (loose coupling)
// I.e. you have a folder named "Releases" and the tasks called "1.1.0", "1.2", "1.5" "pre2.0" in it 
// and a user-defined field of type String with custom lookup set to this script
// Then you will be able to select from "1.1.0", "1.2", "1.5" "pre2.0" in the list
String tId=CSVImport.findTaskIdByName("FIXME the name of task folder");
Collection ret = new ArrayList();
SecuredTaskBean gdsTask = new SecuredTaskBean(tId,task.getSecure()); 
for (Iterator it = gdsTask.getChildren().iterator(); it.hasNext(); ) {
  task = (SecuredTaskBean)it.next(); 
  ret.add(task.getName());
}
return ret;